

require(pheatmap)
require(foreach)
require(RColorBrewer)


makePlot<-function(b1,maxconc=100,file,path){
  pdf(file.path(path,file))
  b1$FC<-paste(b1$Features,b1$Compound)
  #b1<-b1[b1$numberConcTested>3,]
  b1$BMC[is.na(b1$BMC)]<-maxconc; b1$BMC[b1$BMC>b1$maxnonToxicConc]<-maxconc;b1$BMC<-log10(b1$BMC)
  call<-b1$BMC;names(call)<-b1$FC
  anno<-b1[,38:41];temp<-strsplit(anno$feature_categories,"_")
  anno$fea<-b1$Features
  anno$dye<-unlist(lapply(temp,function(x)x[1]))
  anno$comp<-unlist(lapply(temp,function(x)x[2]))
  anno$type<-unlist(lapply(temp,function(x)x[3]))
  anno$ct<-paste(anno$dye,anno$type)
  anno$ct2<-paste(anno$dye,anno$comp)
  anno$dye2<-paste(anno$dye,anno$type)
  anno$comp2<-paste(anno$comp,anno$type)
  dye<-sort(unique(anno$dye));ct<-sort(unique(anno$ct));type<-sort(unique(anno$type));comp<-sort(unique(anno$comp))
  ct2<-sort(unique(anno$ct2));dye2<-sort(unique(anno$dye2));comp2<-sort(unique(anno$comp2))
  com<-unique(anno$Compound);
  fea<-unique(anno$fea)
  pva<-foreach(x=com,.combine="rbind")%do%sapply(fea,function(i){xx=call[anno$Compound==x & anno$fea==i];xx<-xx[!is.na(xx)];yy<-call[anno$fea==i];
  yy<-yy[!is.na(yy)];if(length(xx)>1){print(paste(x,i));};if(length(yy)<1 | length(xx)<1){return(NA)};if(mean(yy)==xx){return(1)};t.test(mu=xx,x=yy,alternative="greater")$p.value})
  rownames(pva)<-com;colnames(pva)<-fea
  prop<-foreach(x=dye,.combine="cbind")%do%{
    rowSums(pva[,anno$fea[anno$dye==x]]<0.05)/rowSums(pva[,anno$fea[anno$dye==x]]<10.05)
  }
  rownames(prop)<-com;colnames(prop)<-dye
  if(colnames(prop)[1]=="Actin"){order1<-c("Generic","Actin","RNA","Lyso","DNA","Golgi","Mito","ER")}else{order1<-c("Generic","DNA","RNA/ER","AGP","Mito")}
  pheatmap(prop[,order1],main=paste(file,"\n color indicates proportion of significant features"),cluster_cols=F,breaks=seq(0,1,.05),
           color=colorRampPalette(rev(brewer.pal(n = 7, name ="RdYlBu")))(20))
  
  prop<-foreach(x=type,.combine="cbind")%do%{
    rowSums(pva[,anno$fea[anno$type==x]]<0.05)/rowSums(pva[,anno$fea[anno$type==x]]<10.05)
  }
  rownames(prop)<-com;colnames(prop)<-type
  order2<-c("Number" , "Morphology" , "Intensity" , "Symmetry" , "Compactness","Distribution","Texture")
  pheatmap(prop[,order2],main=paste(file,"\n color indicates proportion of significant features"),cluster_cols=F,breaks=seq(0,1,.05),
           color=colorRampPalette(rev(brewer.pal(n = 7, name ="RdYlBu")))(20))
  
  prop<-foreach(x=ct,.combine="cbind")%do%{
    rowSums(pva[,anno$fea[anno$ct==x]]<0.05)/rowSums(pva[,anno$fea[anno$ct==x]]<10.05)
  }
  rownames(prop)<-com;colnames(prop)<-ct
  order<-unlist(lapply(order1,function(x){paste(x,order2)}))
  order<-order[is.element(order,ct)]
  pheatmap(prop[,order],main=paste(file,"\n color indicates proportion of significant features"),cluster_cols=F,breaks=seq(0,1,.05),
           color=colorRampPalette(rev(brewer.pal(n = 7, name ="RdYlBu")))(20))
  
  prop<-foreach(x=comp,.combine="cbind")%do%{
    rowSums(pva[,anno$fea[anno$comp==x]]<0.05)/rowSums(pva[,anno$fea[anno$comp==x]]<10.05)
  }
  rownames(prop)<-com;colnames(prop)<-comp
  order3<-c("Cell" , "Nucleus" , "Nucleoli" , "Cytoplasm" , "Membrane" , "Ring")
  pheatmap(prop[,order3],main=paste(file,"\n color indicates proportion of significant features"),cluster_cols=F,breaks=seq(0,1,.05),
           color=colorRampPalette(rev(brewer.pal(n = 7, name ="RdYlBu")))(20))
  
  prop<-foreach(x=comp2,.combine="cbind")%do%{
    rowSums(pva[,anno$fea[anno$comp2==x]]<0.05)/rowSums(pva[,anno$fea[anno$comp2==x]]<10.05)
  }
  rownames(prop)<-com;colnames(prop)<-comp2
  order<-unlist(lapply(order3,function(x){paste(x,order2)}))
  order<-order[is.element(order,comp2)]
  pheatmap(prop[,order],main=paste(file,"\n color indicates proportion of significant features"),cluster_cols=F,breaks=seq(0,1,.05),
           color=colorRampPalette(rev(brewer.pal(n = 7, name ="RdYlBu")))(20))
  prop<-foreach(x=ct2,.combine="cbind")%do%{
    rowSums(pva[,anno$fea[anno$ct2==x]]<0.05)/rowSums(pva[,anno$fea[anno$ct2==x]]<10.05)
  }
  rownames(prop)<-com;colnames(prop)<-ct2
  order<-unlist(lapply(order1,function(x){paste(x,order3)}))
  order<-order[is.element(order,ct2)]
  pheatmap(prop[,order],main=paste(file,"\n color indicates proportion of significant features"),cluster_cols=F,breaks=seq(0,1,.05),color=colorRampPalette(rev(brewer.pal(n = 7, name ="RdYlBu")))(20));
  dev.off()
}



